<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: modelo_llamadas_nhc_5.xml */
/* Generado: 2014-11-25 13:07:49 */

/* Busqueda de registros de la tabla Cr_vista_morosos_compromiso. */
abstract class BaseCr_vista_morosos_compromisoFN extends Cr_vista_morosos_compromisoBN
{
    /* Declaracion de constantes */
    const TipoPrestamo = "TIPOPRESTAMO";
    const NumeroPrestamo = "NUMEROPRESTAMO";
    const Moneda = "MONEDA";
    const MontoPrestado = "MONTOPRESTADO";
    const SaldoPrestamo = "SALDOPRESTAMO";
    const FechaInicio = "FECHAINICIO";
    const FechaFinal = "FECHAFINAL";
    const IdMercado = "IDMERCADO";
    const NombreMercado = "NOMBREMERCADO";
    const IdCliente = "IDCLIENTE";
    const NombreCliente = "NOMBRECLIENTE";
    const Dni = "DNI";

    public $a_Condition = array();
    public $a_OrderBy = array();

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        /*
    	$o_DBConnect = Conexion::getConexion();
        //$o_Resource = $o_DBConnect->getResource();
        $o_Resource = $o_DBConnect;
        */
         $o_Resource=Conexion::getConexion();
         
         
        return $o_Resource;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "TipoPrestamo AS TipoPrestamo, ";
        $s_SQLQuery .= "NumeroPrestamo AS NumeroPrestamo, ";
        $s_SQLQuery .= "Moneda AS Moneda, ";
        $s_SQLQuery .= "MontoPrestado AS MontoPrestado, ";
        $s_SQLQuery .= "SaldoPrestamo AS SaldoPrestamo, ";
        $s_SQLQuery .= "FechaInicio AS FechaInicio, ";
        $s_SQLQuery .= "FechaFinal AS FechaFinal, ";
        $s_SQLQuery .= "IdMercado AS IdMercado, ";
        $s_SQLQuery .= "NombreMercado AS NombreMercado, ";
        $s_SQLQuery .= "IdCliente AS IdCliente, ";
        $s_SQLQuery .= "NombreCliente AS NombreCliente, ";
        $s_SQLQuery .= "Dni AS Dni ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_Comillas=true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "COMILLAS" => $b_Comillas );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece los valores desde un objeto Cr_vista_morosos_compromisoBN */
    public function setByBN( Cr_vista_morosos_compromisoBN $o_Cr_vista_morosos_compromisoBN )
    {
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getTipoPrestamo() ) )
        {
            $this->setTipoPrestamo( $o_Cr_vista_morosos_compromisoBN->getTipoPrestamo() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getNumeroPrestamo() ) )
        {
            $this->setNumeroPrestamo( $o_Cr_vista_morosos_compromisoBN->getNumeroPrestamo() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getMoneda() ) )
        {
            $this->setMoneda( $o_Cr_vista_morosos_compromisoBN->getMoneda() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getMontoPrestado() ) )
        {
            $this->setMontoPrestado( $o_Cr_vista_morosos_compromisoBN->getMontoPrestado() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getSaldoPrestamo() ) )
        {
            $this->setSaldoPrestamo( $o_Cr_vista_morosos_compromisoBN->getSaldoPrestamo() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getFechaInicio() ) )
        {
            $this->setFechaInicio( $o_Cr_vista_morosos_compromisoBN->getFechaInicio() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getFechaFinal() ) )
        {
            $this->setFechaFinal( $o_Cr_vista_morosos_compromisoBN->getFechaFinal() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getIdMercado() ) )
        {
            $this->setIdMercado( $o_Cr_vista_morosos_compromisoBN->getIdMercado() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getNombreMercado() ) )
        {
            $this->setNombreMercado( $o_Cr_vista_morosos_compromisoBN->getNombreMercado() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_vista_morosos_compromisoBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getNombreCliente() ) )
        {
            $this->setNombreCliente( $o_Cr_vista_morosos_compromisoBN->getNombreCliente() );
        }
        if ( !is_null( $o_Cr_vista_morosos_compromisoBN->getDni() ) )
        {
            $this->setDni( $o_Cr_vista_morosos_compromisoBN->getDni() );
        }
    }

    /* Busca un registro por su llave primaria */
    public function selectByPK(  )
    {
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM Cr_vista_morosos_compromiso ";
        $s_SQLQuery .= "LIMIT 1;";

        $o_Cr_vista_morosos_compromisoBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_vista_morosos_compromisoBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_Cr_vista_morosos_compromisoBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getTipoPrestamo() ) ) $s_SQLQuery .= "TipoPrestamo = '".$this->getTipoPrestamo()."' AND ";
        if ( !is_null( $this->getNumeroPrestamo() ) ) $s_SQLQuery .= "NumeroPrestamo = ".$this->getNumeroPrestamo()." AND ";
        if ( !is_null( $this->getMoneda() ) ) $s_SQLQuery .= "Moneda = '".$this->getMoneda()."' AND ";
        if ( !is_null( $this->getMontoPrestado() ) ) $s_SQLQuery .= "MontoPrestado = ".$this->getMontoPrestado()." AND ";
        if ( !is_null( $this->getSaldoPrestamo() ) ) $s_SQLQuery .= "SaldoPrestamo = ".$this->getSaldoPrestamo()." AND ";
        if ( !is_null( $this->getFechaInicio() ) ) $s_SQLQuery .= "FechaInicio = '".$this->getFechaInicio()."' AND ";
        if ( !is_null( $this->getFechaFinal() ) ) $s_SQLQuery .= "FechaFinal = '".$this->getFechaFinal()."' AND ";
        if ( !is_null( $this->getIdMercado() ) ) $s_SQLQuery .= "IdMercado = ".$this->getIdMercado()." AND ";
        if ( !is_null( $this->getNombreMercado() ) ) $s_SQLQuery .= "NombreMercado = '".$this->getNombreMercado()."' AND ";
        if ( !is_null( $this->getIdCliente() ) ) $s_SQLQuery .= "IdCliente = ".$this->getIdCliente()." AND ";
        if ( !is_null( $this->getNombreCliente() ) ) $s_SQLQuery .= "NombreCliente = '".$this->getNombreCliente()."' AND ";
        if ( !is_null( $this->getDni() ) ) $s_SQLQuery .= "Dni = '".$this->getDni()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else 
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM Cr_vista_morosos_compromiso WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        
        $num_rows = 0;
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $num_rows = $a_SQLRow->cnt;
        }
        return $num_rows;
    }

    /* Busca varios registros por los campos establecidos */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM Cr_vista_morosos_compromiso WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";
//echo $s_SQLQuery;
        $a_Cr_vista_morosos_compromisoBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        while ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_vista_morosos_compromisoBN = $this->insertObjectBN( $a_SQLRow );
            $a_Cr_vista_morosos_compromisoBN[] = $o_Cr_vista_morosos_compromisoBN;
        }
        return $a_Cr_vista_morosos_compromisoBN;
    }

    /* Devuelve un objeto Cr_vista_morosos_compromisoBN desde un objeto propel */
    public function insertObjectBN( $o_Cr_vista_morosos_compromiso )
    {
        $o_Cr_vista_morosos_compromisoBN = new Cr_vista_morosos_compromisoBN();
        if ( !is_null( $o_Cr_vista_morosos_compromiso->TipoPrestamo ) ) $o_Cr_vista_morosos_compromisoBN->setTipoPrestamo( $o_Cr_vista_morosos_compromiso->TipoPrestamo );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->NumeroPrestamo ) ) $o_Cr_vista_morosos_compromisoBN->setNumeroPrestamo( ( integer ) $o_Cr_vista_morosos_compromiso->NumeroPrestamo );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->Moneda ) ) $o_Cr_vista_morosos_compromisoBN->setMoneda( $o_Cr_vista_morosos_compromiso->Moneda );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->MontoPrestado ) ) $o_Cr_vista_morosos_compromisoBN->setMontoPrestado( ( float ) $o_Cr_vista_morosos_compromiso->MontoPrestado );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->SaldoPrestamo ) ) $o_Cr_vista_morosos_compromisoBN->setSaldoPrestamo( ( float ) $o_Cr_vista_morosos_compromiso->SaldoPrestamo );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->FechaInicio ) ) $o_Cr_vista_morosos_compromisoBN->setFechaInicio( utilTimestamp::getTimestamp( $o_Cr_vista_morosos_compromiso->FechaInicio, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->FechaFinal ) ) $o_Cr_vista_morosos_compromisoBN->setFechaFinal( utilTimestamp::getTimestamp( $o_Cr_vista_morosos_compromiso->FechaFinal, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->IdMercado ) ) $o_Cr_vista_morosos_compromisoBN->setIdMercado( ( integer ) $o_Cr_vista_morosos_compromiso->IdMercado );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->NombreMercado ) ) $o_Cr_vista_morosos_compromisoBN->setNombreMercado( $o_Cr_vista_morosos_compromiso->NombreMercado );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->IdCliente ) ) $o_Cr_vista_morosos_compromisoBN->setIdCliente( ( integer ) $o_Cr_vista_morosos_compromiso->IdCliente );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->NombreCliente ) ) $o_Cr_vista_morosos_compromisoBN->setNombreCliente( $o_Cr_vista_morosos_compromiso->NombreCliente );
        if ( !is_null( $o_Cr_vista_morosos_compromiso->Dni ) ) $o_Cr_vista_morosos_compromisoBN->setDni( $o_Cr_vista_morosos_compromiso->Dni );
        return $o_Cr_vista_morosos_compromisoBN;
    }
}
?>